Index: modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claimsDemo/QueryGenerator.java
===================================================================
--- modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claimsDemo/QueryGenerator.java	(revision 41790)
+++ modules/uoa-claims -demo/claims-demo/src/main/java/eu/dnetlib/data/claimsDemo/QueryGenerator.java	(revision 41791)
@@ -1,6 +1,10 @@
 package eu.dnetlib.data.claimsDemo;
 
-import eu.dnetlib.data.claims.migration.*;
+import eu.dnetlib.data.claims.migration.entity.Claim;
+import eu.dnetlib.data.claims.migration.entity.Context;
+import eu.dnetlib.data.claims.migration.entity.OpenaireEntity;
+import eu.dnetlib.data.claims.migration.entity.Project;
+import eu.dnetlib.data.claims.migration.entity.Result;
 
 import java.text.SimpleDateFormat;
 import java.util.Date;
@@ -10,7 +14,7 @@
 /**
   ** Insert Queries **
   **/
-    public String generateInsertResultQuery(String openaire_id, String result_type, String title, String collected_from , String external_url, String doi, String orcidworkid, String access_rights , String embargo_end_date, String best_license, String record_path, String record_format) {
+    private String generateInsertResultQuery(String openaire_id, String result_type, String title, String collected_from , String external_url, String doi, String orcidworkid, String access_rights , String embargo_end_date, String best_license, String record_path, String record_format) {
         if(title!=null&&title.contains("'")){
             title=title.replace("'","''");
         }
@@ -87,7 +91,7 @@
                 "    where not exists (select openaire_id from result where openaire_id='"+openaire_id+"')\n" +
                 "    RETURNING openaire_id";
     }
-    public String generateInsertProjectQuery(String openaire_id, String name, String acronym, String funder_id, String funder_name, String funder_acronym) {
+    private String generateInsertProjectQuery(String openaire_id, String name, String acronym, String funder_id, String funder_name, String funder_acronym) {
         if(name!=null) {
             name = name.replace("'", "''");
         }
@@ -128,7 +132,7 @@
                 "    where not exists (select openaire_id from project where openaire_id='"+openaire_id+"')\n" +
                 "    RETURNING openaire_id";
     }
-    public String generateInsertContextQuery(String openaire_id, String name) {
+    private String generateInsertContextQuery(String openaire_id, String name) {
         String fields="openaire_id";
         if(name!=null){
             fields+=",name";
@@ -147,9 +151,17 @@
         SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
         String dateStr=null;
         dateStr=(format.format(date));
+        String fields="claim_date,claimedBy,source_type,target_type, source_id, target_id";
+        if(semantics!=null){
+            fields+=",semantics";
+        }
+        String values="'"+dateStr+"','"+claimedBy+"','"+source_type+"', '"+target_type+"','"+source_id+"','"+target_id+"'";
+        if(semantics!=null){
+            values+=",'"+semantics+"'";
+        }
 
-        return "            INSERT INTO claim( claim_date,claimedBy,source_type,target_type, source_id, target_id, semantics)\n" +
-                "    VALUES ( '"+dateStr+"','"+claimedBy+"','"+source_type+"', '"+target_type+"','"+source_id+"','"+target_id+"','"+semantics+"')\n" +
+        return "     INSERT INTO claim( "+fields+")\n" +
+                "    VALUES ( "+values+")\n" +
                 "    RETURNING id, source_id, target_id\n";
     }
 
@@ -185,7 +197,7 @@
 
     }
     private String generateInsertEntityQuery(OpenaireEntity openaireEntity, String type){
-        String query="has_target_";
+        String query=null;
         if(type==null){
             return null;
         }
@@ -195,7 +207,7 @@
         }else if(type.equals(ClaimUtils.PROJECT)){
             Project project=(Project)openaireEntity;
             query=generateInsertProjectQuery(project.getOpenaireId(),project.getName(),project.getAcronym(),project.getFunderId(),project.getFunderName(),project.getFunderShortName());
-        }else if(type.equals(ClaimUtils.DATASET)||type.equals(ClaimUtils.PUBLICATION)){
+        }else if(type.equals(ClaimUtils.CONTEXT)){
             Context context= (Context)openaireEntity;
             query=generateInsertContextQuery(context.getOpenaireId(),context.getTitle());
         }
@@ -209,9 +221,9 @@
         }
         if(type==null){
             return null;
-        }else if(type.equals("publication")||type.equals("dataset")){
+        }else if(type.equals(ClaimUtils.PUBLICATION)||type.equals(ClaimUtils.DATASET)){
             tablename=tablename+"result";
-        }else if(type.equals("project")||type.equals("context")){
+        }else if(type.equals(ClaimUtils.PROJECT)||type.equals(ClaimUtils.CONTEXT)){
             tablename+=type;
         }
         return tablename;
@@ -242,27 +254,17 @@
      */
     private String createSemanticsType(String sourceType,String targetType){
         String semantics=null;
-        //resultResult_publicationDataset_isRelatedTo
-        semantics="resultResult_"+targetType+sourceType+"_isRelatedTo";
-       /* if(sourceType.equals(ClaimUtils.PUBLICATION)){
-            semantics="resultResult_publication";
-            if(targetType.equals(ClaimUtils.DATASET)){
-                semantics+="Dataset"+"_isRelatedTo";
-            }else if(targetType.equals(ClaimUtils.PUBLICATION)){
-                semantics+="Publication"+"_isRelatedTo";
-            }
-        }else if(sourceType.equals(ClaimUtils.DATASET)){
-            semantics="resultResult_dataset";
-            if(targetType.equals(ClaimUtils.DATASET)){
-                semantics+="Dataset"+"_isRelatedTo";
-            }else if(targetType.equals(ClaimUtils.PUBLICATION)){
-                semantics+="Publication"+"_isRelatedTo";
-            }
-        }*/
+        if((targetType.equals(ClaimUtils.PUBLICATION)||targetType.equals(ClaimUtils.DATASET))&&(sourceType.equals(ClaimUtils.PUBLICATION)||sourceType.equals(ClaimUtils.DATASET))){
+            semantics="resultResult_"+targetType+sourceType+"_isRelatedTo";
+        }
+        else if((targetType.equals(ClaimUtils.PUBLICATION)||targetType.equals(ClaimUtils.DATASET))&&(sourceType.equals(ClaimUtils.PROJECT))){
+            semantics="resultProject_outcome_isProducedBy";
+        }
 
+
         return semantics;
     }
-    public  String generateInsertClaimResultQuery(Result targetResult, Result sourceResult, Claim claim) {
+   /* public  String generateInsertClaimResultQuery(Result targetResult, Result sourceResult, Claim claim) {
 
         return generateInsertClaimResultQuery(generateInsertResultQuery(targetResult.getOpenaireId(), targetResult.getResultType(), targetResult.getTitle(), targetResult.getCollectedFrom(), targetResult.getExternalUrl(), targetResult.getDoi(),targetResult.getOrcidworkid(), targetResult.getAccessRights(), targetResult.getEmbargoEndDate(), targetResult.getBestLicense(), targetResult.getRecordPath(), targetResult.getRecordFormat()),
                 generateInsertResultQuery(sourceResult.getOpenaireId(), sourceResult.getResultType(), sourceResult.getTitle(), sourceResult.getCollectedFrom(), sourceResult.getExternalUrl(), sourceResult.getDoi(), sourceResult.getOrcidworkid(), sourceResult.getAccessRights(), targetResult.getEmbargoEndDate(), sourceResult.getBestLicense(), sourceResult.getRecordPath(),sourceResult.getRecordFormat()),claim);
@@ -310,7 +312,7 @@
                 "    SELECT id, target_id\n" +
                 "    FROM   ins3;";
     }
-
+*/
     /**
      ** Delete Tables Queries **
      **/
@@ -405,24 +407,13 @@
      **/
 
 
-    public String generateSelectDMFClaimsQuery(Integer limit) {
-        return " Select * from claims_view  where type='dmf2actions' and xml NOT ILIKE '%<oaf:concept%' "+(limit>0?" limit "+limit:"");
-    }
     public String generateSelectDMFByIdQuery(String id) {
         return " Select * from claims_view  where type='dmf2actions' and xml NOT ILIKE '%<oaf:concept%' and  resultid='"+id+"'  order by date desc limit 1";
     }
+
     public String generateSelectConceptDMFClaimsQuery(Integer limit) {
         return " Select * from claims_view  where ( type='dmf2actions' or type='updates2actions' ) and xml LIKE '%<oaf:concept%' "+(limit>0?" limit "+limit:"");
     }
-    public String generateSelectCountConceptClaimsQuery(Integer limit ) {
-        return " Select count(*) from claims_view where  ( type='dmf2actions' or type='updates2actions' ) and xml LIKE '%<oaf:concept%' "+(limit>0?" limit "+limit:"");
-
-    }
-    public String generateSelectCountRelationClaimsQuery(Integer limit) {
-        return " Select count(*) from claims_view  where type='rels2actions'  "+(limit>0?" limit "+limit:"");
-
-    }
-
     /**
      *
      * @param limit : for limit > 0 the query adds limit clause, for limit < 0 query skips limit clause
@@ -457,23 +448,158 @@
                 +(limit>0?" limit "+limit:"");
     }
 
-    //used just for Testing
-    public static String generateSelectClaimByIdQuery(String id) {
-        return " Select * from claims_view  where id='"+id+"'";
 
-    }
     public static String generateSelectConceptClaimByIdQuery(String id) {
         return " Select * from claims_view  where ( type='dmf2actions' or type='updates2actions' ) and xml LIKE '%<oaf:concept%' and id='"+id+"'";
 
     }
-/*
     public static String generateSelectRelationClaimByIdQuery(String id) {
         return " Select * from claims_view  where type='rels2actions' and id='"+id+"'";
 
     }
-*/
 
+
     /**
      ** Select - Fetch Queries *New* Database **
      **/
+
+    public static String generateFetchClaimsByUser(String user) {
+        return generateSelectClaimQueryAsUnionOfAllRelations(" claim.claimedBy='" + user + "'");
+
+    }
+    public static String generateFetchClaimsByDate(String dateFrom, String dateTo) {
+        return generateSelectClaimQueryAsUnionOfAllRelations(" claim.claim_date >= '" + dateFrom + "' and claim.claim_date <= '" + dateTo + "' ");
+    }
+    public static String generateFetchClaimsByProject(String projectId) {
+        return " ( " +generateSelectclaimQuery(ClaimUtils.PROJECT,ClaimUtils.PUBLICATION, "source.openaire_id ='"+projectId+"'")+" )";
+    }
+    public static String generateFetchClaimsByFunder(String funderId) {
+        return " ( " +generateSelectclaimQuery(ClaimUtils.PROJECT,ClaimUtils.PUBLICATION, "source.funder_id ='"+funderId+"'")+" )";
+
+    }
+    public static String generateFetchClaimsByResult(String resultId) {
+        String specificWhereClause=" ( source.openaire_id = '"+resultId+"'  or target.openaire_id = '"+resultId+"' )";
+        return " ( " +generateSelectclaimQuery(ClaimUtils.PUBLICATION,ClaimUtils.PUBLICATION, specificWhereClause)+" ) \nunion "+
+                " ( " +generateSelectclaimQuery(ClaimUtils.PROJECT,ClaimUtils.PUBLICATION, specificWhereClause)+" ) \nunion "+
+                " ( " +generateSelectclaimQuery(ClaimUtils.CONTEXT,ClaimUtils.PUBLICATION, specificWhereClause)+" ) ";
+
+    }
+
+
+    private static String getClaimFields() {
+        return " claim.id, claim.claim_date, claim.claimedBy, claim.source_type, claim.target_type, claim.semantics ";
+    }
+    private static String getResultFields(String tableAlias) {
+        return " "+tableAlias+".openaire_id, "+tableAlias+".title, "+tableAlias+".result_type, "+tableAlias+".doi, "+tableAlias+".orcidworkid, "+tableAlias+".access_rights, "+tableAlias+".embargo_end_date, "+tableAlias+".best_license, "+tableAlias+".external_url,  "+tableAlias+".collected_from  ";
+    }
+    private static String getProjectFields(String tableAlias) {
+        return " "+tableAlias+".openaire_id, "+tableAlias+".name, "+tableAlias+".acronym, "+tableAlias+".funder_id, "+tableAlias+".funder_name, null as field6, null as field7, null as field8, null as field9, null as field10 ";
+    }
+    private static String getContextFields(String tableAlias) {
+        return " "+tableAlias+".openaire_id, "+tableAlias+".name, null as field3, null as field4, null as field5, null as field6, null as field7, null as field8, null as field9, null as field10 ";
+    }
+    private static String getFieldsPerType(String type, String tableAlias){
+        String fields= null;
+        if (type == null){
+
+        }else if (type.equals(ClaimUtils.PUBLICATION)||type.equals(ClaimUtils.DATASET)){
+            fields=getResultFields(tableAlias);
+        }else if (type.equals(ClaimUtils.PROJECT)){
+            fields=getProjectFields(tableAlias);
+        }else if (type.equals(ClaimUtils.CONTEXT)){
+            fields=getContextFields(tableAlias);
+        }
+        return fields;
+    }
+    private static String generateSelectclaimQuery(String sourceType, String targetType, String specificWhereClause) {
+        if(sourceType == null || targetType == null){
+            return null;
+        }
+        /*
+        " select "+getClaimFields()+" ,"+getFieldsPerType(sourceType, "source")+" , "+getFieldsPerType(targetType,"target")+
+                " \nfrom claim, "+getTypeForTable(sourceType)+" as source, "+getTypeForTable(targetType)+" as target \n" +
+                "where claim.source_id = source.openaire_id and claim.target_id = target.openaire_id "+((specificWhereClause==null)?"":" and "+specificWhereClause+" ");
+         */
+        return " select "+getClaimFields()+" ,"+getFieldsPerType(sourceType, "source")+" , "+getFieldsPerType(targetType,"target")+
+                " \nfrom claim, "+getTypeForTable(sourceType)+" as source, has_source_"+getTypeForTable(sourceType)+", has_target_"+getTypeForTable(targetType)+", "+getTypeForTable(targetType)+" as target \n" +
+                "where claim.id =  has_source_"+getTypeForTable(sourceType)+".claim_id and   has_source_"+getTypeForTable(sourceType)+".openaire_id = source.openaire_id " +
+                "and claim.id =  has_target_"+getTypeForTable(targetType)+".claim_id and   has_target_"+getTypeForTable(targetType)+".openaire_id  = target.openaire_id "+
+                ((specificWhereClause==null)?"":" and "+specificWhereClause+" ");
+    }
+    private static String generateSelectClaimQueryAsUnionOfAllRelations(String specificWhereClause) {
+        //TODO eliminate unions  based on the to
+        // ClaimUtils.PUBLICATION or ClaimUtils.DATASET  it
+        return " ( " +generateSelectclaimQuery(ClaimUtils.PUBLICATION,ClaimUtils.PUBLICATION, specificWhereClause)+" ) \nunion "+
+                " ( " +generateSelectclaimQuery(ClaimUtils.PROJECT,ClaimUtils.PUBLICATION, specificWhereClause)+" ) \nunion "+
+                " ( " +generateSelectclaimQuery(ClaimUtils.CONTEXT,ClaimUtils.PUBLICATION, specificWhereClause)+" ) ";
+
+
+    }
+    private static String getTypeForTable(String type){
+        if(type == null){
+            return null;
+        }
+        if(type.equals(ClaimUtils.PUBLICATION)||type.equals(ClaimUtils.DATASET)){
+            return "result";
+        }else{
+            return type;
+        }
+    }
+    /**
+     ** Update - Queries *New* Database **
+     **/
+
+    private static void updateResult(){
+
+    }
+    private static void updateProject(){
+
+    }
+    /**
+     ** Delete - Queries *New* Database **
+     **/
+
+    private void deleteFullClaim(String id, String user, String sourceType, String targetType){
+//        String targetQuery =null;
+//        String sourceQuery=null;
+//        targetQuery=generateInsertEntityQuery(claim.getTarget(),claim.getTargetType());
+//        sourceQuery=generateInsertEntityQuery(claim.getSource(),claim.getSourceType());
+//        return generateInsertFullClaimQuery(targetQuery,sourceQuery,claim);
+//
+        String s = "DELETE FROM has_source_"+getTableName(true,sourceType)+" WHERE openaire_id = 10" +
+                "BEGIN;\n" +
+                "WITH source AS ( " +
+                "DELETE FROM "+getTableName(true,sourceType)+" WHERE EXISTS \n" +
+                "    (SELECT 1 FROM "+getTableName(true,sourceType)+" WHERE claim_id = "+id+" );\n" +
+                "    RETURNING openaire_id\n" +
+                "    )"+
+                "DELETE FROM "+sourceType+" WHERE NOT EXISTS \n" +
+                "    (SELECT 1 FROM "+getTableName(true,sourceType)+" , source WHERE openaire_id = 'source.openaire_id' join "+"SELECT 1 FROM "+getTableName(false,sourceType)+" , source WHERE openaire_id = 'source.openaire_id'  );\n" +
+                "WITH target AS ( " +
+                "DELETE FROM "+getTableName(false,targetType)+" WHERE EXISTS \n" +
+                "    (SELECT 1 FROM "+getTableName(false,targetType)+" WHERE claim_id = "+id+" );\n" +
+                "    RETURNING openaire_id\n" +
+                "    )"+
+                "DELETE FROM "+targetType+" WHERE NOT EXISTS \n" +
+                "    (SELECT 1 FROM "+getTableName(true,targetType)+" , source WHERE openaire_id = 'target.openaire_id' join "+"SELECT 1 FROM "+getTableName(false,targetType)+" , source WHERE openaire_id = 'target.openaire_id'  );\n" +
+
+                "WITH source AS ( " +
+                "DELETE FROM "+getTableName(true,sourceType)+" WHERE EXISTS \n" +
+                "    (SELECT 1 FROM "+getTableName(true,sourceType)+" WHERE claim_id = "+id+" );\n" +
+                "    RETURNING openaire_id\n" +
+                "    )"+
+
+                "DELETE FROM claim where id = "+id+";\n" +
+                "COMMIT";
+    }
+//    "drop table  if exists has_source_context;\n" +
+//            "drop table if exists has_source_project;\n" +
+//            "drop table if exists has_source_result;\n" +
+//            "drop table if exists has_target_project;\n" +
+//            "drop table if exists has_target_result;\n" +
+//            "drop table if exists claim;\n" +
+//            "drop table if exists project;\n" +
+//            "drop table if exists result;\n" +
+//            "drop table if exists context;\n" +
+//            "\n ";
 }
\ No newline at end of file
